# std::ostream_iterator< Type, CharT, Traits > Class Template Reference

Provides output iterator semantics for streams. More...

`#include <stream_iterator.h>`

Inheritance diagram for std::ostream_iterator< Type, CharT, Traits >:

[legend]
Collaboration diagram for std::ostream_iterator< Type, CharT, Traits >:

[legend]
List of all members.

## Public Types

typedef output_iterator_tag | iterator_category
| One of the tag types.
typedef void | value_type
| The type "pointed to" by the iterator.
typedef void | difference_type
| Distance between iterators is represented as this type.
typedef void | pointer
| This type represents a pointer-to-value_type.
typedef void | reference
| This type represents a reference-to-value_type.
typedef CharT | char_type
| Public typedef.
typedef Traits | traits_type
| Public typedef.
typedef basic_ostream< CharT, Traits > | ostream_type
| Public typedef.

## Public Member Functions

| ostream_iterator (ostream_type &s)
| Construct from an ostream.
| ostream_iterator (ostream_type &s, const CharT *c)
| ostream_iterator (const ostream_iterator &__obj)
| Copy constructor.
ostream_iterator & | operator= (const Type &value)
| Writes value to underlying ostream using operator<<. If constructed with delimiter string, writes delimiter to ostream.

## Detailed Description

### template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
class std::ostream_iterator< Type, CharT, Traits >

Provides output iterator semantics for streams.

This class provides an iterator to write to an ostream. The type Tp is the only type written by this iterator and there must be an operator<<(Tp) defined.

Parameters:

  | Tp | The type to write to the ostream.
  | CharT | The ostream char_type.
  | Traits | The ostream char_traits.

Definition at line 152 of file stream_iterator.h.

## Member Typedef Documentation

template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
typedef CharT std::ostream_iterator< Type, CharT, Traits >::char_type

| Public typedef. Definition at line 158 of file stream_iterator.h.

typedef void std::iterator< output_iterator_tag , void , void , void , void >::difference_type `[inherited]`

| Distance between iterators is represented as this type. Definition at line 113 of file stl_iterator_base_types.h.

typedef output_iterator_tag std::iterator< output_iterator_tag , void , void , void , void >::iterator_category `[inherited]`

| One of the tag types. Definition at line 109 of file stl_iterator_base_types.h.

template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
typedef basic_ostream<CharT, Traits> std::ostream_iterator< Type, CharT, Traits >::ostream_type

| Public typedef. Definition at line 160 of file stream_iterator.h.

typedef void std::iterator< output_iterator_tag , void , void , void , void >::pointer `[inherited]`

| This type represents a pointer-to-value_type. Definition at line 115 of file stl_iterator_base_types.h.

typedef void std::iterator< output_iterator_tag , void , void , void , void >::reference `[inherited]`

| This type represents a reference-to-value_type. Definition at line 117 of file stl_iterator_base_types.h.

template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
typedef Traits std::ostream_iterator< Type, CharT, Traits >::traits_type

| Public typedef. Definition at line 159 of file stream_iterator.h.

typedef void std::iterator< output_iterator_tag , void , void , void , void >::value_type `[inherited]`

| The type "pointed to" by the iterator. Definition at line 111 of file stl_iterator_base_types.h.

## Constructor & Destructor Documentation

template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
std::ostream_iterator< Type, CharT, Traits >::ostream_iterator | ( | ostream_type & | s | ) | `[inline]`

| Construct from an ostream. Definition at line 169 of file stream_iterator.h.

template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
std::ostream_iterator< Type, CharT, Traits >::ostream_iterator | ( | ostream_type & | s,
|  | const CharT * | c
| ) | `[inline]`

Construct from an ostream.

The delimiter string c is written to the stream after every Tp written to the stream. The delimiter is not copied, and thus must not be destroyed while this iterator is in use.

Parameters:

  | s | Underlying ostream to write to.
  | c | CharT delimiter string to insert.

Definition at line 181 of file stream_iterator.h.

template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
std::ostream_iterator< Type, CharT, Traits >::ostream_iterator | ( | const ostream_iterator< Type, CharT, Traits > & | __obj | ) | `[inline]`

| Copy constructor. Definition at line 185 of file stream_iterator.h.

## Member Function Documentation

template<typename Type, typename CharT = char, typename Traits = char_traits<CharT>>
ostream_iterator& std::ostream_iterator< Type, CharT, Traits >::operator= | ( | const Type & | value | ) | `[inline]`

| Writes value to underlying ostream using operator<<. If constructed with delimiter string, writes delimiter to ostream. Definition at line 191 of file stream_iterator.h. References std::ostream_iterator< Type, CharT, Traits >::operator=(). Referenced by std::ostream_iterator< Type, CharT, Traits >::operator=().

The documentation for this class was generated from the following file:

- stream_iterator.h